package bmsi.edx;

/** Output table for mapping unicode to EDX4978 graphics bytes. */
class EDXGraphics {
  static final char ACS_DIAMOND = 4;
  static final char ACS_CKBOARD = 177;
  static final char ACS_URCORNER = 191;
  static final char ACS_DEGREE = 248;
  static final char ACS_HLINE = 196;
  static final char ACS_ULCORNER = 218;
  static final char ACS_TTEE = 194;
  static final char ACS_PLMINUS = 241;
  static final char ACS_LRCORNER = 217;
  static final char ACS_VLINE = 179;
  static final char ACS_RTEE = 180;
  static final char ACS_LLCORNER = 192;
  static final char ACS_BTEE = 193;
  static final char ACS_LTEE = 195;
  static final char ACS_PLUS = 197;

  /** ASCII control chars are mapped to line drawing chars in the BMS
   EDX4978 client.  The bits of the index represent the four directions
   connected.  The character codes are for Cp437.
  */
  static final char graphics[] = {
    ' ',          ACS_DIAMOND,    ACS_CKBOARD,    ACS_URCORNER,
    ACS_DEGREE,   ACS_HLINE,      ACS_ULCORNER,   ACS_TTEE,
    ACS_PLMINUS,  ACS_LRCORNER,   ACS_VLINE,      ACS_RTEE,
    ACS_LLCORNER, ACS_BTEE,       ACS_LTEE,       ACS_PLUS,
    /* double lines . . . */
    219,          222,            223,            187,
    221,          205,            201,            203,
    220,          188,            186,            185,
    200,          202,            204,            206
  };

  /** Output character mapping. */
  public static void main(String[] argv) throws Exception {
    byte[] b = new byte[32];
    for (int i = 0; i < 32; ++i)
      b[i] = (byte)graphics[i];
    String s = new String(b,"Cp437");
    for (int i = 0; i < 32; ++i) {
      int c = s.charAt(i);
      System.out.println("  case 0x" + Integer.toHexString(c)
      	+ ": return " + i + ";");
    }
    for (int i = 0; i < 32; ++i) {
      System.out.println("0x" + Integer.toHexString(s.charAt(i)) + ",");
    }
  }
}
