/*
 * $Log: EDXPnuts.java,v $
 * Revision 1.2  2002/01/30 19:25:58  stuart
 * Convert to CVS.
 *
 * Revision 1.1  2002/01/16  21:55:27  stuart
 * Initial revision
 *
 */
package bmsi.edx;
import java.io.InputStream;
import java.io.OutputStream;
import java.io.IOException;
import pnuts.lang.*;

/** Provides a pnuts interpreter shell on an EDX4978 terminal.  Pnuts
  is a small interpreted language designed as a companion to Java.
  It is dynamically typed and introspective - and so is useful for
  examining Java objects in a running EDX/Java system.  The
  "edxreq" variable is set to the calling EDXJavaRequest and provides
  and initial reference to the world of Java objects.
 */
public class EDXPnuts extends Context implements EDXServlet {
  public void init() { }
  public void destroy() { }

  public void set(String name,Object val) {
    super.set(name,val);
  }

  public short callJava(EDXServletRequest req) {
    try {
      OutputStream termout = req.getOutputStream();
      setErrorStream(termout,true);
      setOutputStream(termout);
      setTerminalStream(termout,true);
      set("edxreq",(Object)req);
      Pnuts.load(req.getInputStream(),true,this);
    }
    catch (IOException x) {
      return 1;
    }
    return 0;
  }
}
