package bmsi.edx;

public interface Edxdscb {
  public static final short
    DSCBECB = 	0,	/* event control block for i/o operation */	
    DSCBNMC = 	6,	/* 'text' control word */
    DSCBNAM = 	8,	/* data set anme */
    DSCBVLC = 	16,	/* 'text' control word */
    DSCBVOL = 	18,	/* volumn name */
    DSCBCHN = 	24,	/* address of next DSCB in disk chain */
    DSCBKEY = 	26,	/* address key of next DSCB in chain*/
    DSCBADS = 	28,	/* address key of data buffer */
    DSCBORN = 	30,	/* absolute sector number of data set */
    DSCBNEX = 	34,	/* relative record number for next i/o */
    DSCBLNG = 	38,	/* number of (phisical) records in data set */
    DSCBVDE = 	42,	/* address of volumn descriptor entry */
    DSCBPGS = 	44,	/* program size in bytes (pgm only) */
    DSCBARC = 	44,	/* actual record count */
    DSCBWK1 = 	44,	/* diskio work area no. 1*/
    DSCBWK2 = 	46,	/* diskio work area no. 2*/
    DSCBNSV = 	48,	/* user specified record no. */
    DSCBLAD = 	52,	/* load address (pgm only) */
    DSCBRCL = 	52,	/* record length (ds only) */
	    /* Current theory on DSCBPSZ is:
		type 1(data) - both words not set
		type 3(pgm) - 1st word has size in bytes, 2nd word has phisical
		    size in pages
		type ?(undef) - 2nd word has phisical size in pages */
    DSCBPSZ = 	54,	/* program size */
    DSCBEND = 	54,	/* end of data record number (ds only) */
    DSCBENT = 	58,	/* entry point (pgm only) */
    DSCBEDB = 	58,	/* end of data byte count (ds only) */
    DSCBRLD = 	60,	/* rld count (pgm only) */
    DSCBUNU = 	60,	/* unsused (ds only) */
    DSCBFLG = 	62,	/* flags (pgm and ds) */
    DSCBRES = 	64,	/* reserved system use (file descriptor) */

    DSCBL = 	66;	/* length of 'dscb' */

  /** EDX I/O return codes */
  public static final short
    DSBADVOL = 2,	/* volume does not exist */
    DSIOERR = 	5,	/* disk I/O error */
    DSALSMALL = 6,	/* file already allocated smaller */
    DSBADNAME = 8,	/* invalid name */
    DSNOTFOUND = 9,	/* file not found */
    DSNOTOPEN = 11,	/* DSCB not opened */
    DSTYPE = 	17,	/* file is wrong type */
    DSALBIG = 	18;	/* file already allocated bigger */

  /** data set types */
  public static final short
    DMEDAT = 1,		/* member is data */
    DMEPGM = 3,		/* member is program */
    DMEVOL = 4;		/* member is volume */
}
