package bmsi.edx;

/**	Definition of task control block
*
**/

public interface Edxtcb {
  public final static char
    TCBCO = 0,	/* task code word / event control block */
    TCBECB = 0,	/* task event control block */
    TCBCO2 = 2,	/* task code word #2 */
    TCBLSB = 6,	/* level status block save area */
    TCBIAR = 6,	/* instruction address register */
    TCBAKR = 8,	/* address key register */
    TCBLSR = 10,	/* level status register */
    TCBS0 = 12,	/* R0 save area */
    TCBS1 = 14,	/* R1 save area (initialized to 1st inst.) */
    TCBS2 = 16,	/* R2 save area (TCB pointer) */
    TCBS3 = 18,	/* R3 save area */
    TCBS4 = 20,	/* R4 save area */
    TCBS5 = 22,	/* R5 save area */
    TCBS6 = 24,	/* R6 save area */
    TCBS7 = 26,	/* R7 save area */
    TCBSA = 28,	/* R0 save area (temporary) */
    TCBLEV = 30,	/* hardware level (address of ready chain) */
    TCBPRI = 32,	/* task priority (0-255) */
    TCBCHA = 34,	/* task chain location */
    TCBCHNT = 34,	/* task control block */
    TCBCHNK = 36,	/* task chain address key */
    TCBEEC = 38,	/* task end event control block (3 words) */
    TCBXREG = 44,	/* pointer to task register block */
    TCBR1 = 46,	/* task index register 1 (#1) */
    TCBR2 = 48,	/* task index register 2 (#2) */
    TCBR12 = 50,	/* pointer to task register 1 */
    TCBTC1 = 52,	/* task working location 1 */
    TCBTC2 = 54,	/* task working location 2 */
    TCBTC3 = 56,	/* task working location 3 */
    TCBTC4 = 58,	/* task working location 4 */
    TCBTC5 = 60,	/* task working location 5 */
    TCBTC6 = 62,	/* task working location 6 */
    TCBTC7 = 64,	/* task working location 7 */
    TCBTIM = 66,	/* timer value (2 words) */
    TCBTCH = 70,	/* timer chain location */
    TCBTECB = 74,	/* timer ECB */
    TCBCCB = 80,	/* terminal control block address */
    TCBPLP = 82,	/* program load point */
    TCBFLGS = 84,	/* task control flags */

    TCBNDSP = 0x8000,	/* nondispatchable flag */
    TCBTCCB = 0x2000,	/* timer posts CCBECB */
    TCBTUCB = 0x1000,	/* timer posts user ECB */
    TCBQTNO = 0x0800,	/* JMSPTF (??) */
    TCBJOBQ = 0x0400,	/* $JOBQ bit */
    TCBFLTP = 0x0001,	/* floating point flag */

    TCBPTR = 86,	/* pointer to preveous TCB */
    TCBMERR = 88,	/* address of terminal error routine */
    TCBTCW = 90, 	/* task work area 2 (12 words) */
    TCBADS = 114,	/* task target address key */
    TCBEXT = 116,	/* TCB extension pointer */
    TCBTEE = 118,	/* task error exit table pointer */
    TCBRES = 120,	/* reserved (2 words, must be zero) */
    TCBVER = 124,	/* TCB verification pointer */
    TCBSZE = 126,	/* task control block size */
    TCBFLB = 128, 	/* floating level block (optional) */

    TCBLEN = 0xA0;	/* length of task control block */
}
