package bmsi.edx;

/** An entry in an EDX memory map.
 */
public class MapEntry {
  /** The entry is available for allocation. */
  public static final byte FREE = 0;
  /** The entry is occupied by an EDX program. */
  public static final byte PROG = 1;
  /** The entry is allocated as an EDX data area. */
  public static final byte DATA = 2;

  /** The type of entry.  One of <code>FREE</code>, <code>PROG</code>,
      or <code>DATA</code>. */
  public final byte type;
  /** The starting EDX address of the entry. */
  public final char ldpt;

  /** The size of the entry in 256 byte pages. */
  public final short size;

  MapEntry(byte type,char ldpt,short size) {
    this.type = type;
    this.ldpt = ldpt;
    this.size = size;
  }
}
