package bmsi.edx;

/** An EDX menu option enumerated by <code>MenuPath</code>.
    @see MenuPath
    @see MenuFile
    @author Stuart D. Gathman
    Copyright (C) 1998 Business Management Systems, Inc.
 */
public class MenuOption {
  /** The sequence of options to reach this entry from the users initial
      menu.  Options in the path are separated by '/'. */
  public String path;
  /** The EDX program,volume to run for this option. */
  public String prog;
  /** The default BTAS directory to pass to the program. */
  public String dir;
  /** The description of the option.  If the description starts with
  '!', the text following the '!' is passed to the program as a shell parm.
   */
  public String desc;
  /** Return true if this option is another menu. */
  public boolean isMenu() { return prog.startsWith("%"); }
}

