package bmsi.edx;

import bmsi.db.*;
import bmsi.xopen.FType;
import java.io.IOException;

/** The EDX terminal location database.
 */
class Terminal extends Dataset implements EDXServlet {
  public final IntegerField type = new IntegerField(this,"type",0,2);
  public final StringField name = new StringField(this,"name",2,8);
  public final StringField loc = new StringField(this,"loc",10,48);
  public final IntegerField site = new IntegerField(this,"site",58,2);

  public Terminal() {
    super("/edx/TERMINAL",true);
  }

  public void init() {
    try {
      open();
    }
    catch (IOException x) {
      System.err.println(x.toString());
    }
  }
  public void destroy() {
    close();
  }

  /** Return the site id of the current EDX terminal. */
  public synchronized short callJava(EDXServletRequest req) {
    String term = req.getTCB().getPROG().getCCB().getName();
    //String term = req.getTCB().getCCB().getName();
    byte[] b = req.getParm();
    req.setParmLen(2);
    try {
      editKey();
      type.value(1);
      name.value(term);
      if (gotoKey()) {
	FType.stshort((short)site.value(),b,0);
	return 0;
      }
    }
    catch (IOException x) { }
    FType.stshort((short)0,b,0);
    return 1;
  }

}
