package bmsi.edx.fs;
import bmsi.util.JulianDate;
import java.util.StringTokenizer;

public class FSDate extends FSString {
  private JulianDate date;

  public FSDate(FSPanel pan,int fld) {
    super(pan,fld);
  }

  public void paint() {
    if (date == null) {
      setString("");
      return;
    }
    int len = (panel.getFieldLen(fld) < 10) ? 8 : 10;
    setString(date.format(len));
  }

  public boolean validate() {
    StringTokenizer tok = new StringTokenizer(getString()," ");
    if (tok.hasMoreTokens()) {
      try { setDate(new JulianDate(tok.nextToken())); }
      catch (NumberFormatException x) { return false; }
      return isValid();
    }
    setDate(null);
    return true;
  }

  public JulianDate getDate() {
    return date;
  }

  public void setDate(JulianDate dt) {
    date = dt;
    setValid(date == null || date.valid());
    paint();
  }
}
