package bmsi.edx.fs;

import bmsi.util.EditMask;

/** A standalone formatted number field.
   @author Stuart D. Gathman
   Copyright (C) 2000 Business Management Systems, Inc.
 */
public class FSNum extends FSString {
  private long num;
  private EditMask mask;

  public FSNum(FSPanel pan,int fld) {
    super(pan,fld);
  }

  public void paint() {
    EditMask mask = this.mask;
    if (mask == null)
      setString(String.valueOf(num));
    else
      setString(mask.format(num));
  }

  public boolean validate() {
    try {
      String s = getString().trim();
      EditMask mask = this.mask;
      if (mask == null)
	setValue(Integer.parseInt(s));
      else
	setValue((int)mask.unformat(s));
      return true;
    }
    catch (NumberFormatException x) { }
    return false;
  }

  public void setMask(String m) {
    if (m == null)
      mask = null;
    else
      mask = new EditMask(m);
  }

  public void setLongValue(long num) {
    if (num != this.num) {
      this.num = num;
      paint();
    }
    setValid(true);
  }

  public void setValue(int num) { setLongValue(num); }

  public long getLongValue() { return num; }

  public int getValue() {
    int val = (int)num;
    if (val != num)
      throw new ArithmeticException("value too large for int");
    return val;
  }

}
