/*
 * $Log: FSPager.java,v $
 * Revision 1.2  2002/01/29 21:46:02  stuart
 * interpret formfeed
 *
 */
package bmsi.edx.fs;

import java.io.OutputStream;
import java.io.IOException;
import bmsi.edx.EDX4978;

public class FSPager extends OutputStream {
  private String[] pdata = new String[23];
  private StringBuffer buf = new StringBuffer(80);
  private int line;
  private int lmar;
  private EDX4978 sp;

  public FSPager(EDX4978 sp) {
    this.sp = sp;
  }

  public boolean isCancelled() { return sp == null; }
  
  public void write(int c) throws IOException {
    if (sp == null) return;
    switch (c) {
    case '\n': case '\f':
      if (line == pdata.length) {
        line = 0;
	showPage("PF1-STOP ENTER-MORE F6-LEFT F9-RIGHT");
      }
      pdata[line] = buf.toString();
      showLine(line);
      if (c == '\f')
        line = 0;
      else
	++line;
      buf.setLength(0);
      return;
    }
    buf.append((char)c);
  }

  private void showPage(String msg) throws IOException {
    sp.write(23,0,msg,80,true);
    sp.setCursor(23,0);
    for (;;) {
      switch (sp.waitkey()) {
      case 1:
	sp = null;
	throw new IOException("Cancelled by user");
      case 6:
	lmar = 0;
	display();
	continue;
      case 9:
	lmar = 56;
	display();
	continue;
      }
      break;
    }
  }

  private void display() {
    for (int i = 0; i < pdata.length; ++i)
      showLine(i);
  }

  private void showLine(int line) {
    String s = pdata[line];
    if (lmar < s.length())
      sp.write(line,0,s.substring(lmar),80,true);
    else
      sp.write(line,0,"",80,true);
  }

  public void close() throws IOException {
    if (sp == null) return;
    if (buf.length() > 0) {
      sp.write(line,0,buf.toString(),80,true);
      ++line;
    }
    while (line < 23) {
      pdata[line] = "";
      sp.write(line++,0,"",80,true);
    }
    showPage("ENTER TO FINISH");
    sp = null;
  }
  
}
