package bmsi.edx.fs;

public class PFKeyEvent {
  public final FSComp comp;
  public final int pfkey;
  public final int row;
  public final int col;
  public final static int PF_ENTER = 0;
  public final static int PF_STOP = 1;
  public final static int PF_PREV = 2;
  public final static int PF_NEXT = 3;
  public final static int PF_DIVE = 4;
  public final static int PF_FIND = 5;
  public final static int PF_INSERT = 7;
  public final static int PF_DELETE = 8;

  /** The PFKEY that signals field exit when field exit mode is on. */
  public final static int FIELD_EXIT = 100;
  /** The PFKEY that signals that a field was modified. */
  public final static int FIELD_MODIFIED = 1000;
  public final static int FIELD_ENTER = 1001;
  protected boolean consumed = false;

  public PFKeyEvent(FSComp comp,int pfkey,int row,int col) {
    this.comp = comp;
    this.pfkey = pfkey;
    this.row = row;
    this.col = col;
  }

  public boolean isConsumed() { return consumed; }
  public void consume() { consumed = true; }
  public String toString() {
    return "PF" + pfkey + '@' + row + ',' + col;
  }
}
